--- src/libdvdcss.c	2014-08-24 14:02:46.000000000 +0100
+++ src/libdvdcss.c	2014-08-24 14:31:34.000000000 +0100
@@ -153,11 +153,13 @@
 LIBDVDCSS_EXPORT dvdcss_t dvdcss_open ( char *psz_target )
 {
     char psz_buffer[PATH_MAX];
+    char psz_buffer2[PATH_MAX];
     int i_ret;
 
     char *psz_method = getenv( "DVDCSS_METHOD" );
     char *psz_verbose = getenv( "DVDCSS_VERBOSE" );
     char *psz_cache = getenv( "DVDCSS_CACHE" );
+    char *psz_xdgdata = getenv("XDG_DATA_HOME");
 #ifdef DVDCSS_RAW_OPEN
     char *psz_raw_device = getenv( "DVDCSS_RAW_DEVICE" );
 #endif
@@ -244,6 +246,7 @@
         }
 #else
         char *psz_home = NULL;
+        struct stat st;
 #   ifdef HAVE_PWD_H
         struct passwd *p_pwd;
 
@@ -287,7 +290,23 @@
             snprintf( psz_buffer + home_pos, PATH_MAX - home_pos,
                       "%s/.dvdcss", psz_home );
             psz_buffer[PATH_MAX-1] = '\0';
-            psz_cache = psz_buffer;
+            if( psz_xdgdata )
+              snprintf( psz_buffer2, PATH_MAX - 1, "%s/dvdcss", psz_xdgdata );
+            else
+            {
+              strncpy( psz_buffer2, psz_buffer, home_pos );
+              snprintf( psz_buffer2 + home_pos, PATH_MAX - home_pos,
+                      "%s/.local/share/dvdcss", psz_home );
+            }
+            psz_buffer2[PATH_MAX-1] = '\0';
+
+            if ( !stat(psz_buffer, &st) )
+              if ( S_ISDIR( st.st_mode) )
+                if ( stat( psz_buffer2, &st) )
+                  if ( errno == ENOENT )
+                    rename( psz_buffer, psz_buffer2);
+
+            psz_cache = psz_buffer2;
         }
 #endif
     }
